﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace P6_1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //Текстура
        private Texture2D MySprite;
        //Исходная позиция спрайта
        private Vector2 position = new Vector2(150, 200);
        //Угол поворота спрайта (в радианах)
        private float rotation = 0;
        //Исходный оттенок спрайта
        private Color color = new Color(255, 255, 255);
        //Генератор случайных чисел для задания нового цвета
        private Random rand = new Random();
        //Размер спрайта
        private Vector2 scale = new Vector2(1, 1);
        //Начало координат спрайта
        private Vector2 origin;
        //Прямоугольник, ограничивающий спрайт
        private Rectangle spRec = new Rectangle(0, 0, 17, 17);

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            MySprite = Content.Load<Texture2D>("ball");
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            KeyboardState kbState = Keyboard.GetState();
            if (kbState.IsKeyDown(Keys.Up))
                position.Y -= 1;
            if (kbState.IsKeyDown(Keys.Down))
                position.Y += 1;
            if (kbState.IsKeyDown(Keys.Left))
            {
                position.X -= 1;
                rotation -= 0.1f;
            }
            if (kbState.IsKeyDown(Keys.Right))
            {
                position.X += 1;
                rotation += 0.1f;
            }
            if (kbState .IsKeyDown (Keys .A))
            {
                color = new Color ((byte)rand .Next(0,255), (byte)rand .Next (0,255), (byte)rand .Next (0,255));
            }
            if (kbState .IsKeyDown (Keys .S ))
            {
                scale += new Vector2((float)0.2, (float)0.2);
            }
            if (kbState.IsKeyDown(Keys.W))
            {
                scale -= new Vector2((float)0.2, (float)0.2);
            }
           
            origin = (new Vector2 (spRec.Width ,spRec.Height ))/2;
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            spriteBatch.Draw(MySprite, position, spRec, color, rotation , origin , scale , SpriteEffects.None , (float)0);
            spriteBatch.End();

            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }
    }
}
